---
title: Create Sign-On Policy Action (IDENTIFIER_FIRST)
description: The POST {{apiPath}}/v1/environments/{{envID}}/signOnPolicies/{{policyID}}/actions operation creates a new sign-on policy action resource. The priority property specifies the order in which this action (and its conditions) is evaluated when evaluating the policy. Property values range from 1 to {maxInt}. The action with a priority value of 1 is evaluated first.
component: pingone-api
page_id: pingone-api:platform:sign-on-policies/sign-on-policy-actions/create-sign-on-policy-action-identifier_first
canonical_url: https://developer.pingidentity.com/pingone-api/platform/sign-on-policies/sign-on-policy-actions/create-sign-on-policy-action-identifier_first.html
section_ids:
  prerequisites: Prerequisites
  headers: Headers
  body: Body
  example-request: Example Request
---

# Create Sign-On Policy Action (IDENTIFIER\_FIRST)

##

```none
POST {{apiPath}}/v1/environments/{{envID}}/signOnPolicies/{{policyID}}/actions
```

The `POST {{apiPath}}/v1/environments/{{envID}}/signOnPolicies/{{policyID}}/actions` operation creates a new sign-on policy action resource. The `priority` property specifies the order in which this action (and its conditions) is evaluated when evaluating the policy. Property values range from `1` to `{maxInt}`. The action with a `priority` value of `1` is evaluated first.

|   |                                                                                                                                                                                                                                                                               |
| - | ----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------- |
|   | The `condition` property for the sign-on policy action specifies the conditions associated with the action. At least one condition must be met to execute the action. If the `conditions` attribute is omitted from the sign-on policy action, the action is always executed. |

The sample shows the request for an `IDENTIFIER_FIRST` action type.

### Prerequisites

* Refer to [Sign-On Policies](../../sign-on-policies.html) and [Sign-On Policy Actions](../sign-on-policy-actions.html) for important overview information.

* [Create a sign-on policy](../sign-on-policies-1/create-sign-on-policy.html) to get a `policyID` for the endpoint.

* [Create a population](../../populations/create-population.html) to get a `popID` for the body. Refer also to [Populations](../../populations.html).

* Refer to [Identity Providers](../../identity-provider-management/identity-providers.html) to create an identity provider and get a `providerID` for the body. Refer also to [Identity Provider Management](../../identity-provider-management.html).

> **Collapse: Request Model**
>
> | Property                     | Type    | Required? |
> | ---------------------------- | ------- | --------- |
> | `condition.ipRange`          | String  | Optional  |
> | `priority`                   | Integer | Required  |
> | `recovery.enabled`           | Boolean | Required  |
> | `registration.enabled`       | Boolean | Required  |
> | `registration.population.id` | String  | Required  |
> | `type`                       | String  | Required  |
>
> Refer to the [Sign-on policy actions base data model](../sign-on-policy-actions.html#sign-on-policy-actions-base-data-model) for full property descriptions.

### Headers

Authorization      Bearer {{accessToken}}

Content-Type      application/json

### Body

raw ( application/json )

```json
{
    "type": "IDENTIFIER_FIRST",
    "condition": {
        "greater": 600,
        "secondsSince": "${session.lastSignOn.withAuthenticator.pwd.at}"
    },
    "priority": 10,
    "recovery": {
        "enabled": false
    },
    "registration": {
        "enabled": true,
        "population": {
            "id": "{{popID}}"
        }
    },
    "socialProviders": [
        {
            "id": "{{providerID}}"
        }
    ]
}
```

##

### Example Request

* cURL

* C#

* Go

* HTTP

* Java

* jQuery

* NodeJS

* Python

* PHP

* Ruby

* Swift

```shell
curl --location --globoff '{{apiPath}}/v1/environments/{{envID}}/signOnPolicies/{{policyID}}/actions' \
--header 'Content-Type: application/json' \
--header 'Authorization: Bearer {{accessToken}}' \
--data '{
    "type": "IDENTIFIER_FIRST",
    "condition": {
        "greater": 600,
        "secondsSince": "${session.lastSignOn.withAuthenticator.pwd.at}"
    },
    "priority": 10,
    "recovery": {
        "enabled": false
    },
    "registration": {
        "enabled": true,
        "population": {
            "id": "{{popID}}"
        }
    },
    "socialProviders": [
        {
            "id": "{{providerID}}"
        }
    ]
}'
```

```csharp
var options = new RestClientOptions("{{apiPath}}/v1/environments/{{envID}}/signOnPolicies/{{policyID}}/actions")
{
  MaxTimeout = -1,
};
var client = new RestClient(options);
var request = new RestRequest("", Method.Post);
request.AddHeader("Content-Type", "application/json");
request.AddHeader("Authorization", "Bearer {{accessToken}}");
var body = @"{" + "\n" +
@"    ""type"": ""IDENTIFIER_FIRST""," + "\n" +
@"    ""condition"": {" + "\n" +
@"        ""greater"": 600," + "\n" +
@"        ""secondsSince"": ""${session.lastSignOn.withAuthenticator.pwd.at}""" + "\n" +
@"    }," + "\n" +
@"    ""priority"": 10," + "\n" +
@"    ""recovery"": {" + "\n" +
@"        ""enabled"": false" + "\n" +
@"    }," + "\n" +
@"    ""registration"": {" + "\n" +
@"        ""enabled"": true," + "\n" +
@"        ""population"": {" + "\n" +
@"            ""id"": ""{{popID}}""" + "\n" +
@"        }" + "\n" +
@"    }," + "\n" +
@"    ""socialProviders"": [" + "\n" +
@"        {" + "\n" +
@"            ""id"": ""{{providerID}}""" + "\n" +
@"        }" + "\n" +
@"    ]" + "\n" +
@"}";
request.AddStringBody(body, DataFormat.Json);
RestResponse response = await client.ExecuteAsync(request);
Console.WriteLine(response.Content);
```

```golang
package main

import (
  "fmt"
  "strings"
  "net/http"
  "io"
)

func main() {

  url := "{{apiPath}}/v1/environments/{{envID}}/signOnPolicies/{{policyID}}/actions"
  method := "POST"

  payload := strings.NewReader(`{
    "type": "IDENTIFIER_FIRST",
    "condition": {
        "greater": 600,
        "secondsSince": "${session.lastSignOn.withAuthenticator.pwd.at}"
    },
    "priority": 10,
    "recovery": {
        "enabled": false
    },
    "registration": {
        "enabled": true,
        "population": {
            "id": "{{popID}}"
        }
    },
    "socialProviders": [
        {
            "id": "{{providerID}}"
        }
    ]
}`)

  client := &http.Client {
  }
  req, err := http.NewRequest(method, url, payload)

  if err != nil {
    fmt.Println(err)
    return
  }
  req.Header.Add("Content-Type", "application/json")
  req.Header.Add("Authorization", "Bearer {{accessToken}}")

  res, err := client.Do(req)
  if err != nil {
    fmt.Println(err)
    return
  }
  defer res.Body.Close()

  body, err := io.ReadAll(res.Body)
  if err != nil {
    fmt.Println(err)
    return
  }
  fmt.Println(string(body))
}
```

```http
POST /v1/environments/{{envID}}/signOnPolicies/{{policyID}}/actions HTTP/1.1
Host: {{apiPath}}
Content-Type: application/json
Authorization: Bearer {{accessToken}}

{
    "type": "IDENTIFIER_FIRST",
    "condition": {
        "greater": 600,
        "secondsSince": "${session.lastSignOn.withAuthenticator.pwd.at}"
    },
    "priority": 10,
    "recovery": {
        "enabled": false
    },
    "registration": {
        "enabled": true,
        "population": {
            "id": "{{popID}}"
        }
    },
    "socialProviders": [
        {
            "id": "{{providerID}}"
        }
    ]
}
```

```java
OkHttpClient client = new OkHttpClient().newBuilder()
  .build();
MediaType mediaType = MediaType.parse("application/json");
RequestBody body = RequestBody.create(mediaType, "{\n    \"type\": \"IDENTIFIER_FIRST\",\n    \"condition\": {\n        \"greater\": 600,\n        \"secondsSince\": \"${session.lastSignOn.withAuthenticator.pwd.at}\"\n    },\n    \"priority\": 10,\n    \"recovery\": {\n        \"enabled\": false\n    },\n    \"registration\": {\n        \"enabled\": true,\n        \"population\": {\n            \"id\": \"{{popID}}\"\n        }\n    },\n    \"socialProviders\": [\n        {\n            \"id\": \"{{providerID}}\"\n        }\n    ]\n}");
Request request = new Request.Builder()
  .url("{{apiPath}}/v1/environments/{{envID}}/signOnPolicies/{{policyID}}/actions")
  .method("POST", body)
  .addHeader("Content-Type", "application/json")
  .addHeader("Authorization", "Bearer {{accessToken}}")
  .build();
Response response = client.newCall(request).execute();
```

```javascript
var settings = {
  "url": "{{apiPath}}/v1/environments/{{envID}}/signOnPolicies/{{policyID}}/actions",
  "method": "POST",
  "timeout": 0,
  "headers": {
    "Content-Type": "application/json",
    "Authorization": "Bearer {{accessToken}}"
  },
  "data": JSON.stringify({
    "type": "IDENTIFIER_FIRST",
    "condition": {
      "greater": 600,
      "secondsSince": "${session.lastSignOn.withAuthenticator.pwd.at}"
    },
    "priority": 10,
    "recovery": {
      "enabled": false
    },
    "registration": {
      "enabled": true,
      "population": {
        "id": "{{popID}}"
      }
    },
    "socialProviders": [
      {
        "id": "{{providerID}}"
      }
    ]
  }),
};

$.ajax(settings).done(function (response) {
  console.log(response);
});
```

```javascript
var request = require('request');
var options = {
  'method': 'POST',
  'url': '{{apiPath}}/v1/environments/{{envID}}/signOnPolicies/{{policyID}}/actions',
  'headers': {
    'Content-Type': 'application/json',
    'Authorization': 'Bearer {{accessToken}}'
  },
  body: JSON.stringify({
    "type": "IDENTIFIER_FIRST",
    "condition": {
      "greater": 600,
      "secondsSince": "${session.lastSignOn.withAuthenticator.pwd.at}"
    },
    "priority": 10,
    "recovery": {
      "enabled": false
    },
    "registration": {
      "enabled": true,
      "population": {
        "id": "{{popID}}"
      }
    },
    "socialProviders": [
      {
        "id": "{{providerID}}"
      }
    ]
  })

};
request(options, function (error, response) {
  if (error) throw new Error(error);
  console.log(response.body);
});
```

```python
import requests
import json

url = "{{apiPath}}/v1/environments/{{envID}}/signOnPolicies/{{policyID}}/actions"

payload = json.dumps({
  "type": "IDENTIFIER_FIRST",
  "condition": {
    "greater": 600,
    "secondsSince": "${session.lastSignOn.withAuthenticator.pwd.at}"
  },
  "priority": 10,
  "recovery": {
    "enabled": False
  },
  "registration": {
    "enabled": True,
    "population": {
      "id": "{{popID}}"
    }
  },
  "socialProviders": [
    {
      "id": "{{providerID}}"
    }
  ]
})
headers = {
  'Content-Type': 'application/json',
  'Authorization': 'Bearer {{accessToken}}'
}

response = requests.request("POST", url, headers=headers, data=payload)

print(response.text)
```

```php
<?php
require_once 'HTTP/Request2.php';
$request = new HTTP_Request2();
$request->setUrl('{{apiPath}}/v1/environments/{{envID}}/signOnPolicies/{{policyID}}/actions');
$request->setMethod(HTTP_Request2::METHOD_POST);
$request->setConfig(array(
  'follow_redirects' => TRUE
));
$request->setHeader(array(
  'Content-Type' => 'application/json',
  'Authorization' => 'Bearer {{accessToken}}'
));
$request->setBody('{\n    "type": "IDENTIFIER_FIRST",\n    "condition": {\n        "greater": 600,\n        "secondsSince": "${session.lastSignOn.withAuthenticator.pwd.at}"\n    },\n    "priority": 10,\n    "recovery": {\n        "enabled": false\n    },\n    "registration": {\n        "enabled": true,\n        "population": {\n            "id": "{{popID}}"\n        }\n    },\n    "socialProviders": [\n        {\n            "id": "{{providerID}}"\n        }\n    ]\n}');
try {
  $response = $request->send();
  if ($response->getStatus() == 200) {
    echo $response->getBody();
  }
  else {
    echo 'Unexpected HTTP status: ' . $response->getStatus() . ' ' .
    $response->getReasonPhrase();
  }
}
catch(HTTP_Request2_Exception $e) {
  echo 'Error: ' . $e->getMessage();
}
```

```ruby
require "uri"
require "json"
require "net/http"

url = URI("{{apiPath}}/v1/environments/{{envID}}/signOnPolicies/{{policyID}}/actions")

http = Net::HTTP.new(url.host, url.port);
request = Net::HTTP::Post.new(url)
request["Content-Type"] = "application/json"
request["Authorization"] = "Bearer {{accessToken}}"
request.body = JSON.dump({
  "type": "IDENTIFIER_FIRST",
  "condition": {
    "greater": 600,
    "secondsSince": "\${session.lastSignOn.withAuthenticator.pwd.at}"
  },
  "priority": 10,
  "recovery": {
    "enabled": false
  },
  "registration": {
    "enabled": true,
    "population": {
      "id": "{{popID}}"
    }
  },
  "socialProviders": [
    {
      "id": "{{providerID}}"
    }
  ]
})

response = http.request(request)
puts response.read_body
```

```swift
let parameters = "{\n    \"type\": \"IDENTIFIER_FIRST\",\n    \"condition\": {\n        \"greater\": 600,\n        \"secondsSince\": \"${session.lastSignOn.withAuthenticator.pwd.at}\"\n    },\n    \"priority\": 10,\n    \"recovery\": {\n        \"enabled\": false\n    },\n    \"registration\": {\n        \"enabled\": true,\n        \"population\": {\n            \"id\": \"{{popID}}\"\n        }\n    },\n    \"socialProviders\": [\n        {\n            \"id\": \"{{providerID}}\"\n        }\n    ]\n}"
let postData = parameters.data(using: .utf8)

var request = URLRequest(url: URL(string: "{{apiPath}}/v1/environments/{{envID}}/signOnPolicies/{{policyID}}/actions")!,timeoutInterval: Double.infinity)
request.addValue("application/json", forHTTPHeaderField: "Content-Type")
request.addValue("Bearer {{accessToken}}", forHTTPHeaderField: "Authorization")

request.httpMethod = "POST"
request.httpBody = postData

let task = URLSession.shared.dataTask(with: request) { data, response, error in
  guard let data = data else {
    print(String(describing: error))
    return
  }
  print(String(data: data, encoding: .utf8)!)
}

task.resume()
```
